#include "TCP.h"
#include "utility/w5500.h"
#include "utility/socket.h"

ConnectionStatusSimple EthernetMaketClient::connectNonBlock(IPAddress ip, uint16_t port) {
 
  if (_sock != MAX_SOCK_NUM) {
    // Serial.println(F("connectNonBlock"));
    uint8_t status_ = status();
    switch (status_) {
      case SnSR::CLOSED:
        // Serial.println(F("CLOSED"));
        _sock = MAX_SOCK_NUM;
        return CONNECT_FAIL;
        break;
      case SnSR::ESTABLISHED:
        // Serial.println(F("ESTABLISHED"));
        return CONNECT_SUCCESS;
        break;
      default:
        // Serial.print(F("status "));
        // Serial.println(status_,HEX);
        return CONNECT_CONNECTING;
        break;
    }
  }
  for (int i = 0; i < MAX_SOCK_NUM; i++) {
    uint8_t s = w5500.readSnSR(i);
    if (s == SnSR::CLOSED || s == SnSR::FIN_WAIT || s == SnSR::CLOSE_WAIT) {
      _sock = i;
      break;
    }
  }

  if (_sock == MAX_SOCK_NUM)
    return CONNECT_FAIL;

  _srcport++;
  if (_srcport == 0) _srcport = 1024;
  socket(_sock, SnMR::TCP, _srcport, 0);

  if (!::connect(_sock, rawIPAddress(ip), port)) {
    _sock = MAX_SOCK_NUM;
    return CONNECT_FAIL;
  }
  
  return CONNECT_CONNECTING;
}

void EthernetMaketClient::disconnect(){
  if (_sock == MAX_SOCK_NUM)
    return;
    ::disconnect(_sock);
}

void EthernetMaketClient::close(){
  if (_sock == MAX_SOCK_NUM)
    return;
    ::close(_sock);
    _sock = MAX_SOCK_NUM;
}

// void EthernetMaketClient::stop() {
//   if (_sock == MAX_SOCK_NUM)
//     return;

//   // attempt to close the connection gracefully (send a FIN to other side)
//   disconnect(_sock);
//   unsigned long start = millis();

//   // wait a second for the connection to close
//   uint8_t s;
//    do {
//      s = status();
//      if (s == SnSR::CLOSED)
//      break; // exit the loop
//      delay(1);
//    } while (millis() - start < 1000);

//   // if it hasn't closed, close it forcefully
//   if (status() != SnSR::CLOSED)
//     close(_sock);

//   EthernetClass::_server_port[_sock] = 0;
//   _sock = MAX_SOCK_NUM;
// }
